// KeyMapper
// Marielle Lange - mlange@widged.com
package
{

   import flash.events.Event;
   import flash.events.KeyboardEvent;
   import flash.events.MouseEvent;
   import flash.events.TimerEvent;
   import flash.utils.Timer;
   import flash.display.Stage;
   import flash.display.Sprite;

   public class KeyMapper {

    private var isShiftDown:Boolean;
    private var timer:Timer;
    private var sprite:Sprite;

    private var mappings:Object;
    public static const UP:int                     = 1;
    public static const DOWN:int                   = 2;
    public static const SPACE:int                  = 3;
    public static const ARROW_UP:int               = 4;
    public static const MOUSE_DOWN:int       = 5;
    public static const MOUSE_DOWN_SHIFT:int = 6;
    private var customEvents:Array = [UP, DOWN, SPACE, ARROW_UP, MOUSE_DOWN, MOUSE_DOWN, MOUSE_DOWN_SHIFT];
    
    public function KeyMapper(sprite:Sprite, keyMap:Object) : void { 
       var stage:Stage = sprite.stage;
       this.sprite = sprite;
       isShiftDown = false;
       
       initializeMappings(keyMap);
        timer = new Timer(100);
        timer.addEventListener(TimerEvent.TIMER, onTimerTick)
       
        stage.addEventListener("keyDown", function(e:KeyboardEvent):void 
        {
           switch(e.keyCode) 
           {
              case 38: // up
               sprite.dispatchEvent(new Event(mappings[UP]));
               break;
              case 40: // down
               sprite.dispatchEvent(new Event(mappings[DOWN]));
               break;
              case 32: // spacebar
               sprite.dispatchEvent(new Event(mappings[SPACE]));
               break;
           }
        });
        
        stage.addEventListener("keyUp",   function(e:KeyboardEvent):void 
        {
           switch(e.keyCode) 
           {
              case 38: // up
              case 40: // down
               sprite.dispatchEvent(new Event(mappings[ARROW_UP]));
               break;
           }
        });

        stage.addEventListener("mouseDown",function(e:MouseEvent):void {
            sprite.dispatchEvent(new Event(mappings[MOUSE_DOWN]));
            isShiftDown = e.shiftKey
            timer.start()
        });

        stage.addEventListener("mouseUp",function(e:MouseEvent):void 
        { 
            timer.stop();
            isShiftDown = e.shiftKey
        });
    }
    
    private function initializeMappings(obj:Object):void
    {
      mappings = new Object();
      for (var i:int = 0; i < customEvents.length; i++)
      {
         var k:int = int(customEvents[i]);
         mappings[k] = "undefined";
         if(obj.hasOwnProperty(k)) { mappings[k] = obj[k]; }
      }
    }
    
    private function onTimerTick(event:TimerEvent):void
    {
       if(isShiftDown)
             sprite.dispatchEvent(new Event(mappings[MOUSE_DOWN_SHIFT]));
         else
             sprite.dispatchEvent(new Event(mappings[MOUSE_DOWN]));
    }
    
}
}